// JavaScript Document
Drupal.behaviors.china_address = function(context) {
  $('.china-address-province-ajax').change(function(){
    province = $(this);
    chinaAddressProvinceChange(province);
  })
  
  $('.china-address-city-ajax').change(function(){
    city = $(this);
    chinaAddressCityChange(city);
  })
}

function chinaAddressProvinceChange(province){ 
   $.ajax({
      url: Drupal.settings.basePath + 'china_address/province/callback/' + province.val(),
      type: "GET", 
      dataType: "json",
      timeout: 6000, 
      error: function(xhr, status, error){
        alert('status=' + xhr.statusText + '   status=' + status + '  error=' + error);
      },
      beforeSend: chinaAddressLoading(province),
      success: function(data){   
        // rm the ajax loading icon
        chinaAddressLoadingRm(province);
        
        // reset city option
        var city = province.parents('.china-address-field').find('.china-address-city-ajax');
        city.find('option').remove();
        $.each(data.cities, function (key ,value) {
          city.append(
              $('<option></option>').val(key).html(value)                            
          ); 
        });
        //selectedCity = data.selected_city;
        
        // reset county option
        chinaAddressCityChange(city)
        
      }
   })
}

function chinaAddressCityChange(city){ 
   $.ajax({
      url: Drupal.settings.basePath + 'china_address/city/callback/' + city.val(),
      type: "GET", 
      dataType: "json",
      timeout: 6000, 
      error: function(xhr, status, error){
        alert('status=' + xhr.statusText + '   status=' + status + '  error=' + error);
      },
      beforeSend: chinaAddressLoading(city),
      success: function(data){   
        // rm the ajax loading icon
        chinaAddressLoadingRm(city);
        
        // reset county option
        var county = city.parents('.china-address-field').find('.china-address-county-ajax');
        county.find('option').remove();
        $.each(data.counties, function (key ,value) {
          county.append(
              $('<option></option>').val(key).html(value)                            
          ); 
        });
      }
   })
}

function chinaAddressLoading(obj) {
  var throbber =$('<div class="ahah-progress ahah-progress-throbber"><div class="throbber">&nbsp;</div></div>');
  obj.after(throbber);
}

function chinaAddressLoadingRm(obj) {
  obj.parent().find('.ahah-progress').fadeOut("slow");
}